/**************** File Main of 10_1_3  ***************/
// Author      : Oren Garten	
// Modify Date : 15/07/09				 
// Project     : 10_1_3
// Using       : iostream, assert.h, ctime 
// Description : Implementation of Question 10_1_3 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include <ctime> //for rand()
#include <cmath> //for sqrt(),pow()


#define  N 4

typedef  unsigned int   Uint; 
typedef  unsigned short Ushort; 
typedef  unsigned char  Uchar; 


/**************** Declarations ***************/

//---------------------------------

// Struct      : Point3d
// Description : 
// Fields      : 
typedef struct Point3d
{
	float x,y,z ;
}Point3d;

//---------------------------------
// Function    : distance()
// Description : 
//				 
// Input       : 
//				 
// Returns     : float
float distance(Point3d a, Point3d b )
{
	return	sqrt(pow(a.x-b.x ,2)+pow(a.y-b.y ,2)+pow(a.z-b.z,2));

}

//---------------------------------
// Function    : dispARR()
// Description : 
//				 
// Input       : 
//				 
// Returns     : void

void dispARR(Point3d* arr ,int n)
{
	
	assert(n<=N);

	for(int i = 0;i<n;i++)
	{
		printf("arr[%d]:(%05.2lf, %05.2lf, %05.2lf)\n", i,arr[i].x, arr[i].y, arr[i].z);
	}

	printf("\n");
}
//---------------------------------
// Function    : initARR()
// Description : 
//				 
// Input       : 
//				 
// Returns     : void

void initARR(Point3d* arr ,int n)
{
	
	printf("Initializing point array[%d]...\n\n",n);
	assert(n<=N);

	for(int i = 0;i<n;i++)
	{
		arr[i].x = (rand()%100)/2.3;
		arr[i].y = (rand()%100)/2.3;
		arr[i].z = (rand()%100)/2.3;
		
		printf("arr[%d]:(%05.2lf, %05.2lf, %05.2lf)\n",i,arr[i].x, arr[i].y, arr[i].z);
	}
	printf("\n");
}
//---------------------------------
// Function    : maxDistance()
// Description : 
//				 
// Input       : 
//				 
// Returns     : float

float maxDistance(Point3d* arr ,int n)
{
	assert(n<=N);

	int i,j;
	float currdist;
	float maxdist = 0;

	for(i = 0;i<n;i++)
	{
		for(j = 0;j<i;j++)
		{
			currdist = distance(arr[i],arr[j]);
			maxdist	=  (currdist > maxdist)? currdist: maxdist;	
		}
	}
	return maxdist;

}

//---------------------------------

int main()
{
	system("cls"); 
	srand(time(0));

	Point3d pointArr[N];

	initARR(pointArr,N);
	dispARR(pointArr,N);

	printf("maxDistance in the array is: %lf\n", maxDistance(pointArr,N));

	
	/*	
	//simple distance test 
	pointArr[0].x = 0;
	pointArr[0].y = 1;
	pointArr[0].z = 2;

	pointArr[1].x = 3;
	pointArr[1].y = 4;
	pointArr[1].z = 5;

	float d= distance(pointArr[0],pointArr[1]);
	printf("d = %lf\n",d);
	*/


	return 0;
}



