/**************** File Main of PointInCircle  ***************/
// Author      : Oren Garten	
// Modify Date : 15/07/09				 
// Project     : PointInCircle
// Using       : iostream, assert.h, ctime 
// Description : Implementation of Question PointInCircle 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include <ctime> //for rand()
#include <cmath>



typedef  unsigned int   Uint; 


/**************** Declarations ***************/

// Struct      : Point2d
// Description : 
// Fields      : 
typedef struct Point2d
{
	float x,y ;

}Point2d;


//---------------------------------

// Struct      : Circle
// Description : 
// Fields      : 
typedef struct Circle{
	Point2d center; 
	double radius;
}Circle;
//---------------------------------
// Function    : distance()
// Description : 
//				 
// Input       : 
//				 
// Returns     : float

float distance(Point2d* pa, Point2d* pb)
{
	return sqrt( pow(pa->x - pb->x , 2) + pow(pa->y - pb->y , 2) );
}
//---------------------------------
// Function    : point_in_circ()
// Description : 
//				 
// Input       : 
//				 
// Returns     : bool

bool  point_in_circ(Circle* pcirc, Point2d* ppoint)
{
	float d = distance(&(pcirc->center), ppoint );
	
	printf("distance: = %05.2lf\n",d);
	
	return ( d < pcirc->radius ); 
}

//---------------------------------
// Function    : init_point
// Description : initializes a point with random numbers [0:99]
//				 
// Input       : pointer to point wanted to be initialized
//				 
// Returns     : void

void init_point(Point2d* ppoint)
{
	ppoint->x= (rand()%100)/2.1;
	ppoint->y= (rand()%100)/2.1;
}

//---------------------------------
// Function    : init_circ
// Description : initializes circle    
//				 
// Input       : 
//				 
// Returns     : void

void init_circ(Circle* pcirc)
{
	init_point(&(pcirc->center));
	pcirc->radius = (rand()%100)/2.1;
}
//---------------------------------
// Function    : display_point()
// Description : 
//				 
// Input       : 
//				 
//				 
// Returns     : void

void display_point(Point2d* ppoint)
{
	printf("point:(x,y)= (%05.2lf, %05.2lf)\n", ppoint->x, ppoint->y);
}
//---------------------------------
// Function    : display_circle()
// Description : 
//				 
// Input       : 
//				 
//				 
// Returns     : void

void display_circle(Circle* pcirc)
{
	printf("circle: center:");
	display_point(&(pcirc->center));

	printf("circle: radius:= %05.2lf\n",pcirc->radius);
}
//---------------------------------

int main()
{
	system("cls"); 
	srand(time(0));

	Point2d SomePoint;
	Circle MyCircle;
	
	init_point(&SomePoint);
	init_circ(&MyCircle);

	display_point(&SomePoint);
	printf("\n");
	display_circle(&MyCircle);

	printf("\n");
	
	if(point_in_circ(&MyCircle, &SomePoint))
		printf("point is inside circle.\n");
	else
		printf("sorry, point is not inside circle.\n");

	
	
	return 0;
}



