/**************** File Main of 10_2_1  ***************/
// Author      : Oren Garten	
// Modify Date : 15/07/09				 
// Project     : 10_2_1
// Using       : iostream, assert.h, ctime 
// Description : Implementation of Question 10_2_1 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include <ctime> //for rand()
#include <cmath> //for sqrt(),pow()


#define  N 10

typedef  unsigned int   Uint; 
typedef  unsigned short Ushort; 
typedef  unsigned char  Uchar; 


/**************** Declarations ***************/

//---------------------------------

// Struct      : Point2d
// Description : 
// Fields      : 
typedef struct Point2d
{
	float x,y ;
}Point2d;

//---------------------------------

// Struct      : Rect
// Description : 
// Fields      : 
typedef struct Rect
{
	Point2d upRight; 
	Point2d botLeft ;
}Rect;


//---------------------------------
// Function    : initPoint()
// Description : initialize a point with randomal real values in range[0:99]
//				 
// Input       : ppnt - pointer to the point wished to be initialized
//				 
// Returns     : void

void initPoint(Point2d* ppnt)
{
	
	ppnt->x = (rand()%100)/1.01;
	ppnt->y = (rand()%100)/1.01;
	
}
//---------------------------------
// Function    : dispPoint()
// Description : displays a point coordinates
//				 
// Input       : ppnt - pointer to the point wished to be displayed
//				 
// Returns     : void

void dispPoint(Point2d* ppnt)
{
	printf("(%05.2lf, %05.2lf)\n",ppnt->x, ppnt->y); 
}
//---------------------------------
// Function    : initRect()
// Description : initialize a rectangle with randomal real values in range[0:99]
//				 
// Input       : psomeRect - pointer to the rectangle wished to be initialized
//				 
// Returns     : void

void initRect(Rect* psomeRect)
{
	
	initPoint(&(psomeRect->botLeft));
	//we must make sure that upper right point is positioned upper right 
	//relativly to botleft. 
	//We do that by adding randomal positive values to both botleft's coordinates  
	psomeRect->upRight.x = psomeRect->botLeft.x + rand()%20;
	psomeRect->upRight.y = psomeRect->botLeft.y + rand()%20;
	
}
//---------------------------------
// Function    : dispRect()
// Description : displays a rectangle parameters
//				 
// Input       : psomeRect - pointer to the rectangle wished to be displayed
//				 
// Returns     : void

void dispRect(Rect* psomeRect)
{
	printf("Rect's Bottom left point:");
	dispPoint(&(psomeRect->botLeft));
	
	printf("Rect's Upper right point:");
	dispPoint(&(psomeRect->upRight));
	
	printf("\n");
}
//---------------------------------
// Function    : initPointArr()
// Description : initialize an array of points with randomal real value in range[0:99]
//				 
// Input       : arr - pointer to first point in the array
//				 n - number of items in the array
//				 
// Returns     : void

void initPointArr(Point2d* arr ,int n)
{
	
	printf("Initializing point array[%d]...\n\n",n);
	assert(n<=N);

	for(int i = 0;i<n;i++)
	{
		initPoint(&arr[i]);
		printf("%d:\t",i); 
		dispPoint(&arr[i]);
	}
	printf("\n");
}
//---------------------------------
// Function    : minDelimitRect()
// Description : finds the smallest rectangle which still contains all points in an array 
//				 of points. This is actually the rectancle which Bottom left and 
//				 Upper right points are (Xmin,Ymin) , (Xmax, Ymax) respectively.
//				 
// Input       : arr - pointer to first point in the array
//				 n - number of items in the array
//				 
// Returns     : Rect - an object of the found rectangle
Rect minDelimitRect(Point2d* arr ,int n)
{
	printf("Searching for the smallest rectangle delimiting all points ...\n\n");
	assert(n<=N);

	float Xmin,Xmax,Ymin,Ymax;
	Xmin = Xmax = arr[0].x; 
	Ymin = Ymax = arr[0].y;
	
	for(int i = 0;i<n;i++)
	{
		Xmax = (arr[i].x > Xmax)? arr[i].x : Xmax;
		Ymax = (arr[i].y > Ymax)? arr[i].y : Ymax;

		Xmin = (arr[i].x < Xmin)? arr[i].x : Xmin;
		Ymin = (arr[i].y < Ymin)? arr[i].y : Ymin;
	}

	Rect resRect;
	resRect.botLeft.x = Xmin;
	resRect.botLeft.y = Ymin;

	resRect.upRight.x = Xmax;
	resRect.upRight.y = Ymax;

	return resRect;


}
//---------------------------------

int main()
{
	system("cls"); 
	srand(time(0));

	Point2d pointArr[N];
	
	initPointArr(pointArr,N);

	
	Rect delimitingRect = minDelimitRect(pointArr,N);
	
	printf("The Smallest delimiting rectangle is: \n");
	dispRect(&delimitingRect);


	return 0;
}



